/** @(#)includes.h Created on: <30-Nov-2003 06:56:03 Z4303>
 *  Last Time-stamp: <30-Nov-2003 08:05:02 Z4303>
 *
 *  \file includes.h
 *  \ingroup Build Environment
 *  \brief  All project files include this file to make porting easier.
 *
 * Items that every one needs to know about are contained in this file.
 * The rational is that only this file, compiler.h and project.h will
 * need change to port the code to other build environments.
 *
 * If we included the specific CPU, Compiler, and Project Settings in each
 * source file then porting because a long tedious process.
 *
 * Using a editor such as EMACS with template capabilities makes creating new
 * projects quick and easy.
 *
 */

/*lint -save -e755 -e756 Disable warning(s), this file only, global macro/typedef 'Symbol' (Location) not referenced */

#ifndef _INCLUDES_H_
#define _INCLUDES_H_ (1)

/*
 * Compiler dependent issues are resolved by compiler.h.
 * Must be first include file, later files depend on
 * defines from it.
 *
 * compiler.h is the only file allowed to contain CPU specific header file references.
 */
#include "compiler.h"

/*
 * Project wide configuration information is contained in this file:
 */
#include "project.h"

#endif /* _INCLUDES_H_ */

/*lint -restore */
