/** @(#)debounce.h Created on: <30-Nov-2003 19:01:02 Z4303>
 *  Last Time-stamp: <30-Nov-2003 07:42:06 Z4303>
 *
 *  \file debounce.c
 *  \ingroup Inputs
 *  \brief  Debounces Switches and/or Buttons
 *
 */

/*lint -save -e755 -e756 Disable warning(s), this file only, global macro/typedef 'Symbol' (Location) not referenced */

/*
 * Localize declarations and space allocations to this header file.
 * Only the parent file will set DEFINE_SPACE_x, no other file will set it.
 * For example hardware.c will set DEFINE_SPACE_HARDWARE_H, no other file
 * including the hardware.h file will set it.
 *
 * This technique keeps both the declarations and the space definitions in this
 * single file.  The parent file will allocated space and all others will
 * reference this file with 'extern'.
 */
#ifndef _DEBOUNCE_H_
#define _DEBOUNCE_H_ (1)

#ifdef  DEFINE_SPACE_DEBOUNCE_H
#define EXTERN_DEBOUNCE
#else
#define EXTERN_DEBOUNCE extern
#endif

#if defined(__cplusplus) && __cplusplus
 extern "C" {
#endif

uint8_t debounce_buttons( uint8_t buttons );

#if defined(__cplusplus) && __cplusplus
 }
#endif

#endif /* _DEBOUNCE_H_ */

/*lint -restore */
