/** @(#)led_digits.h Created on: <30-Nov-2003 06:54:54 Z4303>
 *  Last Time-stamp: <30-Nov-2003 08:08:22 Z4303>
 *
 *  \file led_digits.h
 *  \ingroup I/O
 *  \brief  Items that deal with the 5x7 LED display.
 *
 */

/*lint -save -e755 -e756 Disable warning(s), this file only, global macro/typedef 'Symbol' (Location) not referenced */

/*
 * Localize declarations and space allocations to this header file.
 * Only the parent file will set DEFINE_SPACE_x, no other file will set it.
 * For example hardware.c will set DEFINE_SPACE_HARDWARE_H, no other file
 * including the hardware.h file will set it.
 *
 * This technique keeps both the declarations and the space definitions in this
 * single file.  The parent file will allocated space and all others will
 * reference this file with 'extern'.
 */
#ifndef _LED_DIGITS_H_
#define _LED_DIGITS_H_ (1)

#ifdef  DEFINE_SPACE_LED_DIGITS_H
#define EXTERN_LED_DIGITS
#else
#define EXTERN_LED_DIGITS extern
#endif

EXTERN_LED_DIGITS volatile uint8_t led_digits_digit_u8;
EXTERN_LED_DIGITS volatile uint8_t isr_led_digits_timer_state_u8;

#if defined(__cplusplus) && __cplusplus
 extern "C" {
#endif

/* Prototypes: */
void isr_led_digits_timer( void );
void led_digits_all_off( void );
void led_digits_string_out( uint8_t *string );

#if defined(__cplusplus) && __cplusplus
 }
#endif

#endif /* _LED_DIGITS_H_ */

/*lint -restore */
