/** @(#)reflex_game.h Created on: <30-Nov-2003 06:53:03 Z4303>
 *  Last Time-stamp: <30-Nov-2003 08:42:46 Z4303>
 *
 *  \file reflex_game.h
 *  \ingroup Esterel Automation
 *  \brief Interface to reflex_game.c.
 *
 */

/*lint -save -e755 -e756 Disable warning(s), this file only, global macro/typedef 'Symbol' (Location) not referenced */

#ifndef _REFLEX_GAME_H_
#define _REFLEX_GAME_H_ (1)

/*
 * Localize declarations and space allocations to this header file.
 * Only the parent file will set DEFINE_SPACE_x, no other file will set it.
 * For example hardware.c will set DEFINE_SPACE_HARDWARE_H, no other file
 * including the hardware.h file will set it.
 *
 * This technique keeps both the declarations and the space definitions in this
 * single file.  The parent file will allocated space and all others will
 * reference this file with 'extern'.
 */
#ifdef  DEFINE_SPACE_REFLEX_GAME_H
#define EXTERN_REFLEX_GAME
#else
#define EXTERN_REFLEX_GAME extern
#endif

#include "includes.h"

#include "hardware.h"

#if defined(__cplusplus) && __cplusplus
 extern "C" {
#endif

/* INPUT FUNCTIONS: */
void REFLEX_GAME_I_MS();
void REFLEX_GAME_I_COIN();
void REFLEX_GAME_I_READY();
void REFLEX_GAME_I_STOP();

/* OUTPUT ACTIONS FUNCTIONS: */
void REFLEX_GAME_O_DISPLAY( int reaction_time );
void REFLEX_GAME_O_RING_BELL( void );

/* AUTOMATON RESET: */
int REFLEX_GAME_reset();

/* AUTOMATON ENGINE: */
int REFLEX_GAME();

/* Macros and function not declared in this file are found in hardware.h */

#if defined(__cplusplus) && __cplusplus
 }
#endif

#endif /* _REFLEX_GAME_H_ */

/*lint -restore */
